#!/bin/sh
###############################################################################
#  BasicTest.sh
#  Copyright (C) 2002, John F. Hubbard
#
#  This library is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Lesser General Public
#  License as published by the Free Software Foundation; either
#  version 2.1 of the License, or (at your option) any later version.
#
#  This library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public
#  License (LGPL) along with this library; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#  As this software is very much in use and evolving, you may want to check
#  this web site for periodic updates: http://www.hubbard-software.com
#  You may also post feedback, comments, and (someday) patches there.
#
#  My goal is to provide quality, open source programmer tools that are
#  available to everyone-including commercial users. This is intended to help
#  the software profession, by providing quality tools that cannot be taken
#  away from you, no matter where you work.  The LGPL license seems to allow
#  for all of this, which is why I use it.
#  -jfh, December, 2002.
#
#  $Revision: 1.16 $
#  $Date: 2002/12/15 19:45:07 $
#  $Author: jhubbard $
###############################################################################

if [ ${TARGET} = "" ];then
	TARGET=LINUX_X86
	echo "Warning: TARGET was not set, so TARGET is now set equal to ${TARGET}."
fi

${TARGET}/CodeSketch -version
${TARGET}/CodeSketch -help
${TARGET}/CodeSketch -h
${TARGET}/CodeSketch -diagnostics_only
${TARGET}/CodeSketch -diag

${TARGET}/CodeSketch -ow          				-diagnostics_only
${TARGET}/CodeSketch -overwrite  				-diagnostics_only
${TARGET}/CodeSketch -q           				-diagnostics_only
${TARGET}/CodeSketch -quiet      				-diagnostics_only
${TARGET}/CodeSketch -q -ow      				-diagnostics_only
${TARGET}/CodeSketch -ns GoldNameSpace          -diagnostics_only
${TARGET}/CodeSketch -namespace BlueNameSpace  -diagnostics_only
${TARGET}/CodeSketch -no_ut          			-diagnostics_only
${TARGET}/CodeSketch -no_unit_test  			-diagnostics_only
${TARGET}/CodeSketch -no_mf          			-diagnostics_only
${TARGET}/CodeSketch -no_makefile  			-diagnostics_only

${TARGET}/CodeSketch -i          				-diagnostics_only
${TARGET}/CodeSketch -interface  				-diagnostics_only
${TARGET}/CodeSketch -no_dd          			-diagnostics_only
${TARGET}/CodeSketch -no_dump_diagnostics  	-diagnostics_only
${TARGET}/CodeSketch -no_cv          			-diagnostics_only
${TARGET}/CodeSketch -no_check_valid  			-diagnostics_only
${TARGET}/CodeSketch -no_icc          			-diagnostics_only
${TARGET}/CodeSketch -no_sccs          			-diagnostics_only
${TARGET}/CodeSketch -no_sccs_keywords  			-diagnostics_only
${TARGET}/CodeSketch -open         				-diagnostics_only
${TARGET}/CodeSketch -open_source  			-diagnostics_only
${TARGET}/CodeSketch -c "Example Copyright (c) 2010" 			-diagnostics_only
${TARGET}/CodeSketch -copyright "Example Copyright (c) 2011" 	-diagnostics_only
${TARGET}/CodeSketch -file  "ExampleBlueBaseFile"  				-diagnostics_only
${TARGET}/CodeSketch -base_filename  "ExampleRedBaseFile"		-diagnostics_only
${TARGET}/CodeSketch -output_dir  "./ExampleDirectoryOne"		-diagnostics_only
${TARGET}/CodeSketch -o  "./ExampleDirectoryTwo"  				-diagnostics_only
${TARGET}/CodeSketch -initials "JFH"          					-diagnostics_only
${TARGET}/CodeSketch -in "ABC"          						-diagnostics_only

${TARGET}/CodeSketch -ansi_c          			-diagnostics_only
${TARGET}/CodeSketch -char_driver     			-diagnostics_only
${TARGET}/CodeSketch -char     					-diagnostics_only
${TARGET}/CodeSketch -char -sparse				-diagnostics_only
${TARGET}/CodeSketch -block_driver     			-diagnostics_only
${TARGET}/CodeSketch -block		     			-diagnostics_only
${TARGET}/CodeSketch -char_driver   -os lynx 	-diagnostics_only
${TARGET}/CodeSketch -block_driver  -os linux	-diagnostics_only
${TARGET}/CodeSketch -block_driver  -os solaris	-diagnostics_only

if [ -d cstemp ];     then rm -r cstemp;     fi;
mkdir cstemp

COLOR=Blue
${TARGET}/CodeSketch -output_dir  "./cstemp" -class ${COLOR} \
                     -author AutoTester
cd cstemp;
cat makefile
cat ${COLOR}.cpp;
cat ${COLOR}.icc;cat ${COLOR}.h;cat ${COLOR}_UnitTest.cpp;cd ..
mv cstemp/makefile cstemp/makefile_${COLOR}

COLOR=Red
${TARGET}/CodeSketch -output_dir  "cstemp" -class Red -author Anyone
${TARGET}/CodeSketch -output_dir  "cstemp" -class Red -no_icc \
                     -author "Joe Smith" -ow
cd cstemp;cat ${COLOR}.cpp;cat ${COLOR}.h;cat ${COLOR}_UnitTest.cpp;cd ..
mv cstemp/makefile cstemp/makefile_${COLOR}

COLOR=Yellow
${TARGET}/CodeSketch -output_dir  "cstemp" -class ${COLOR} -no_cv \
                     -no_dd -author "Joe Smith" -ow
cd cstemp;cat ${COLOR}.cpp;cat ${COLOR}.icc;cat ${COLOR}.h;
cat ${COLOR}_UnitTest.cpp;cd ..
mv cstemp/makefile cstemp/makefile_${COLOR}

COLOR=Orange
${TARGET}/CodeSketch -output_dir  "cstemp" -class ${COLOR} -ns color_test \
                     -author "Joe F. Smith" -ow -initials "JFS"
cd cstemp;cat ${COLOR}.cpp;cat ${COLOR}.icc;cat ${COLOR}.h;
cat ${COLOR}_UnitTest.cpp;cd ..
mv cstemp/makefile cstemp/makefile_${COLOR}

COLOR=Fruits
${TARGET}/CodeSketch -output_dir  "cstemp" -class "Apple Pear Blueberry" \
       -base_filename ${COLOR} -ns fruit_namespace -author "Joe Smith" -ow
cd cstemp;
	cat ${COLOR}.cpp;cat ${COLOR}.icc;cat ${COLOR}.h;
	cat ${COLOR}_UnitTest.cpp;
	cat makefile
cd ..
mv cstemp/makefile cstemp/makefile_${COLOR}

COLOR=Purple
${TARGET}/CodeSketch -output_dir  "cstemp" -class ${COLOR} \
                     -ansi_c -author "Joe Smith" -ow
cd cstemp;cat ${COLOR}.c;cat ${COLOR}.h;cat ${COLOR}_UnitTest.cpp;cd ..
mv cstemp/makefile cstemp/makefile_${COLOR}

COLOR=White
${TARGET}/CodeSketch -output_dir  "cstemp" -class ${COLOR} -char_driver \
                     -author "Joe Smith" -ow # using default value of os
cd cstemp;
cat ${COLOR}.c;
cat Build${COLOR}.bash
cat CommonBuildRoutines.bash
cat StandardCodeSketchCommands.h
cat makefile
cd ..
mv cstemp/makefile cstemp/makefile_${COLOR}

COLOR=Black
${TARGET}/CodeSketch -output_dir  "cstemp" -class ${COLOR} -ns color_test \
                     -author "Joe Smith" -ow -open_source
cd cstemp;cat ${COLOR}.cpp;cat ${COLOR}.icc;cat ${COLOR}.h;
cat ${COLOR}_UnitTest.cpp;cd ..
mv cstemp/makefile cstemp/makefile_${COLOR}

COLOR=Grey
${TARGET}/CodeSketch -output_dir  "cstemp" -class ${COLOR} -ns color_test \
                     -author "Joe Smith" -open_source -no_sccs -interface
cd cstemp;cat ${COLOR}.h;cat ${COLOR}_UnitTest.cpp;cd ..
mv cstemp/makefile cstemp/makefile_${COLOR}

COLOR=Green
${TARGET}/CodeSketch -output_dir  "cstemp" -class ${COLOR} -char_driver \
                     -os lynx -author "George Jones" -ow -open_source \
					 -copyright "Copyright (C) 3001, G.Jones"
cd cstemp;
cat ${COLOR}.c
cat ${COLOR}_CreateInfo.c
cat ${COLOR}_info.h
cat ${COLOR}_imports.txt
cat Build${COLOR}.bash
cat CommonBuildRoutines.bash
cat StandardCodeSketchCommands.h
cat makefile
cd ..
mv cstemp/makefile cstemp/makefile_${COLOR}

cd cstemp
	make -silent -f makefile_Blue
	make -silent -f makefile_Red
	make -silent -f makefile_Yellow
	make -silent -f makefile_Orange
	make -silent -f makefile_Fruits
	make -silent -f makefile_Purple
	make -silent -f makefile_Black
	make -silent -f makefile_Grey
	chmod a+x *.bash
#	BuildWhite.bash  # Can only build device drivers on their own platform
cd ..
