/* ****************************************************************************
 *  StandardCodeSketchCommands.h
 *  Copyright (C) 2002, John F. Hubbard
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License (LGPL) along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  As this software is very much in use and evolving, you may want to check
 *  this web site for periodic updates: http://www.hubbard-software.com
 *  You may also post feedback, comments, and (someday) patches there.
 *
 *  My goal is to provide quality, open source programmer tools that are
 *  available to everyone--including commercial users. This is intended to help
 *  the software profession, by providing quality tools that cannot be taken
 *  away from you, no matter where you work.  The LGPL license seems to allow
 *  for all of this, which is why I use it.
 *  --jfh, December, 2002.
 *
 *  $Revision: 1.4 $
 *  $Date: 2002/12/14 20:52:17 $
 *  $Author: jhubbard $
 *************************************************************************** */

#ifndef JFH_STANDARD_CODE_SKETCH_COMMANDS_H
#define JFH_STANDARD_CODE_SKETCH_COMMANDS_H

#define STANDARD_COMMAND_BUFFER_SIZE_CODE_SKETCH  512

#ifdef __cplusplus
extern "C" {
#endif

typedef struct StandardCodeSketchCommands
{
	 long	mCommand;
	 long	mDataIn;
	 long	mDataOut;
	 char	mBufferIn [ STANDARD_COMMAND_BUFFER_SIZE_CODE_SKETCH ];
	 char	mBufferOut[ STANDARD_COMMAND_BUFFER_SIZE_CODE_SKETCH ];
} StandardCodeSketchCommands;

#define CODE_SKETCH_OVERALL_COMMAND_TO_IOCTL 	    1000
#define CODE_SKETCH_COMMAND_DUMP 					1001
#define CODE_SKETCH_COMMAND_SEEK_FORWARD 			1002
#define CODE_SKETCH_COMMAND_SEEK_BACK 				1003

#ifdef __cplusplus
 }
#endif

#endif /* JFH_STANDARD_CODE_SKETCH_COMMANDS_H */

