#include <sstream>
#include <rmi/convert.h>

namespace RMI {

template<class T>
T
convert_(const string& str)
{
   std::istringstream stream(str);
   T value;
   stream >> value;
   return value;
}

template<class T>
string
convert_(const T& value)
{
   std::ostringstream stream;
   stream << value;
   return stream.str();
}

template<>
inline
string
convert_(const string& value)
{
   return value;
}

string convert(char const* const& value) { return convert_(value); }
string convert(char      * const& value) { return convert_(value); }
string convert(void const* const& value) { return convert_(value); }
string convert(void      * const& value) { return convert_(value); }
string convert(double      const& value) { return convert_(value); }
string convert(int         const& value) { return convert_(value); }
string convert(string      const& value) { return convert_(value); }

template<> void*  convert <void*>(const string& str) { return convert_ <void*>(str); }
template<> int    convert   <int>(const string& str) { return convert_   <int>(str); }
template<> double convert<double>(const string& str) { return convert_<double>(str); }
template<> string convert<string>(const string& str) { return convert_<string>(str); }

} // End of RMI namespace.
