/////////////////////////////////////////////////////////////////////
// Code accompanying "Embedded Angle" column in CUJ
// Copyright (c) 2002 Miro Samek 
/////////////////////////////////////////////////////////////////////
#ifndef fsm_h
#define fsm_h

typedef short Signal;
struct Event {
   Signal sig;
};

class Fsm {
public:
   typedef void (Fsm::*State)(Event const *);

   Fsm(State initial) { myState = initial; }
   virtual ~Fsm() {}  // virtual Xtor
   void init(Event const *e = 0) { (this->*myState)(e); }
   void dispatch(Event const *e) { (this->*myState)(e); }
   void tran(State target) { myState = target; }
private:
   State myState;
};

#endif // fsm_h
