#ifndef RMI_STRING_H
#define RMI_STRING_H

#include <stdarg.h>
#include <string>
#include <vector>

struct Lock
{
   void acquire() {}
   void release() {}
};

typedef const char cchar;

struct String : public std::string
{
   typedef std::string super;

   String () : super() {}
   String (cchar* s) : super(s) {}
   String (const super& s) : super(s) {}
   
   static String va_format(cchar*, va_list) throw(std::bad_alloc);
   static String    format(cchar*, ...)     throw(std::bad_alloc);

   // Split using ANY character from the 'delimiters' list.

   static std::vector<String> split (cchar*, 
                                     const String& delimiters, 
                                     const bool ignore_empty_tokens = true);

   std::vector<String>        split (const String& delimiters, 
                                     const bool ignore_empty_tokens = true) const;

};

typedef std::vector<String> Strings; // Convenience definition.

#endif // RMI_STRING_H
