#include <rmi/String.h>
#include <rmi/convert.h>

namespace RMI {

string convert(char const* const& value)
{ 
   printf("string convert(char const* const&)\n");
   return string(value); 
}

string convert(char* const& value) 
{ 
   printf("string convert(const char*&)\n");
   return string(value); 
}

string convert(void const* const& value)
{ 
   printf("string convert(void const* const&)\n");
   return String::format("0x%X", value); 
}

string convert(void* const& value) 
{ 
   printf("string convert(const void*&)\n");
   return String::format("0x%X", value); 
}

string convert(double const& value) 
{ 
   printf("string convert(const double&)\n");
   return String::format("%lf", value); 
}
string convert(int const&    value) 
{ 
   printf("string convert(const int&)\n");
   return String::format("%d", value); 
}
string convert(string const& value) 
{ 
   printf("string convert(const string&)\n");
   return value; 
}

template<>
void* 
convert<void*>(const string& str)
{
   printf("convert<void*>(const string&)\n");
   void* value = 0;
   sscanf(str.c_str(), "0x%X", &value);
   return value;
}

template<> 
int      
convert<int>(const string& str)
{
   printf("convert<int>(const string&)\n");
   int value = 0;
   sscanf(str.c_str(), "%d", &value);
   return value;
}

template<>
double
convert<double>(const string& str)
{
   printf("convert<double>(const string&)\n");
   double value = 0;
   sscanf(str.c_str(), "%lf", &value);
   return value;
}

template<> 
string
convert<string>(const string& str)
{
   printf("convert<string>(const string&)\n");
   return str;
}

} // End of RMI namespace.
